# DATA from: Web page for Analysis of Financial Time Series
#(Ruey S. Tsay, Wiley 2002, Financial Engineering)
#ISBN 0-471-41544-8

# Monthly log returns of IBM stock & SP500: m-ibmspln.dat

is=read.table("m-ibmspln.dat") #

## VAR(5)
p=5 
d=2
T=nrow(is)-p

## parameters
a=2
gamma=0
B=2000  ## 12-13min? 

## weight function for sequential statistics
vaha=T*exp((2+gamma)*log((1:(T-1))*((T-1):1)/(T^2)))

statka <- function (eps,a) {
    .C("statka2",e1=as.double(eps[,1]),e2=as.double(eps[,2]),a=as.double(a),v=as.double(vaha),n=as.integer(nrow(eps)-1),nn=as.integer((nrow(eps)-1)*nrow
(eps)/2),t=double(1))$t
}
dyn.load("./statka2.so")


print(date())

names(is)=c("IBM","SP500")


xts=ts(data=is,start=1,end=p+T)
arest=ar(xts,order=p,aic=FALSE,method="ols")
eps=arest$resid[(p+1):(p+T),]  
bet=arest$ar 

stat=statka(eps,a=a)

ceps=scale(eps,center=TRUE,scale=FALSE) ## centrered residuals
stat.b=numeric(B)
for (b in 1:B) {
    ## bootstrap
    i.b=sample(1:T,T+p,replace=TRUE)
    ##
    x.b=matrix(rep(NA,(T+p)*d),nrow=(T+p),ncol=d)
    x.b[1:p,]=ceps[i.b[1:p],] ## starting values
    for(i in (p+1):(p+T)) {
        x.b[i,]=ceps[i.b[i],]   # bootstrap under H0 
        for (j in 1:p) {
            x.b[i,]=x.b[i,]+bet[j,,]%*%(x.b[i-j,])
        }
    }
    xts.b=ts(data=x.b,start=1,end=p+T)
    eps.b=ar(xts.b,order=1,aic=FALSE,method="ols")$resid[(p+1):(p+T),]
    stat.b[b]=statka(eps.b,a=a)
}

pval=mean(stat.b>=stat)
print(pval)
print(date())

#
# RESULTS
#
#[1] "Mon Apr 25 10:17:39 2016"
#[1] 0.0045
#[1] "Mon Apr 25 10:29:52 2016"
