T=200
nsim=100  #1000 in the paper
B=200     #2000 in the paper
cp=1.0
p=1
d=2
a=3
gamma=0
scale1=1
scale2=1
kor1=0.2
kor2=0.2
w=2
set.seed(2101)
unseed=2101

library(mvtnorm)

########################################################
########################################################

cpt=T*cp           # changepoint

## vahova funkce pro tu sekvencni statistiku
vaha=T*exp((2+gamma)*log((1:(T-1))*((T-1):1)/(T^2)))

## VAR coefficients for the simulation
beta1 = matrix(c(0.5,0.2,0.2,0.1),2,2)
beta2 = matrix(c(0.5,0.2,0.2,0.1),2,2)

## distribution before the change
reps1 = function(n,kr=kor) {rmvnorm(n, mean = rep(0,2), sigma = matrix(c(1,kr,kr,1),nrow=2))}

## distribution after the change
reps2 = function(n,kr=kor) {rmvnorm(n, mean = rep(0,2), sigma = matrix(c(1,kr,kr,1),nrow=2))}

statka <- function (eps,a) {
    .C("statka2",e1=as.double(eps[,1]),e2=as.double(eps[,2]),a=as.double(a),v=as.double(vaha),n=as.integer(nrow(eps)-1),nn=as.integer((nrow(eps)-1)*nrow(eps)/2),t=double(1))$t
}
dyn.load("./statka2.so")

pvals=numeric(nsim)

for (s in 1:nsim) {

    
    print(date())
    print(s)
###
### before the change point
    reps=reps1   
    scale=scale1 
    beta=beta1
    kor=kor1
    
  ## 1/ simulations of AR(p) 

    x=matrix(rep(NA,(T+p)*d),nrow=(T+p),ncol=d)
    x[1:p,]=reps(p)*scale

    for(i in (p+1):(p+T)) {
        x[i,]=t(x[(i-p):(i-1),])%*%t(beta)+reps(1)*scale   #
        if (i==round(p+cpt)) {
###   after the change point
            reps=reps2 
            scale=scale2 
            beta=beta2
            kor=kor2
        }
    }

    xts=ts(data=x,start=1,end=p+T)
    arest=ar(xts,order=1,aic=FALSE,method="ols")
    eps=arest$resid[(p+1):(p+T),]  ## default demean=TRUE
    bet=arest$ar[1,,] 

    stat=statka(eps,a=a)

################
### bootstrap 
################

    ceps=scale(eps,center=TRUE,scale=FALSE) ## centered residuals
    stat.b=numeric(B)
    for (b in 1:B) {
        ## bootstrap
        i.b=sample(1:T,T+p,replace=TRUE)
        ##
        x.b=matrix(rep(NA,(T+p)*d),nrow=(T+p),ncol=d)
        x.b[1:p,]=ceps[i.b[1:p],] ## starting values

        for(i in (p+1):(p+T)) {
            x.b[i,]=t(x.b[(i-p):(i-1),])%*%t(bet)+ceps[i.b[i],]   # bootstrap under H0 
         }

        xts.b=ts(data=x.b,start=1,end=p+T)
        eps.b=ar(xts.b,order=1,aic=FALSE,method="ols")$resid[(p+1):(p+T),]

        stat.b[b]=statka(eps.b,a=a)
    }
    pvals[s]=mean(stat.b>=stat)
}
####################
####################

pow01=mean(pvals<=0.01)
pow05=mean(pvals<=0.05)
pow10=mean(pvals<=0.10)

print(pow01)
print(pow05)
print(pow10)


